/*
 * $Id: error.H,v 1.4 1995/10/05 21:10:29 asf Exp $
 */

/*
    This file is part of Addventure
    Copyright (C) 1994  Allen S. Firstenberg
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _ERROR_H
#define _ERROR_H

/***************************************************************************/

typedef enum { ADDVERR_UNKNOWN, ADDVERR_LOCKED, ADDVERR_INVALID_TARGET,
               ADDVERR_NOT_EXIST, ADDVERR_EMPTY, ADDVERR_HTML,
               ADDVERR_EXISTS, ADDVERR_FINISHED, ADDVERR_NONEXTROOM
             } AddvErrorType;

/***************************************************************************/

void addventure_error( char *module, AddvErrorType kind,
                       char *roomw = NULL, char *desc = NULL );

/***************************************************************************/

#endif

/*
 * $Log: error.H,v $
 * Revision 1.4  1995/10/05  21:10:29  asf
 * Added the No Next Room error
 *
 * Revision 1.3  1995/01/01  17:38:46  asf
 * Added the "room word" to the error messages
 *
 * Revision 1.2  1994/12/25  11:07:51  asf
 * Added ADDVERR_HTML
 *
 * Revision 1.1  1994/08/26  09:08:03  asf
 * Initial revision
 *
 */
