/*
 * $Id: response.H,v 1.2 1994/12/15 19:51:19 asf Exp $
 */

/*
    This file is part of Addventure
    Copyright (C) 1994  Allen S. Firstenberg
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _RESPONSE_H
#define _RESPOSE_H

#include <list.H>

#include "option.H"

/***************************************************************************/

class Response{
public:
  // Constructors/destructors
  Response( char *string );    //parse it
  Response( int parent, int room, char *address );
  ~Response();

  // Accessors
  int parent();
  int room();
  char *address();

  char *string();    // The single line representation

private:
  int _parent;
  int _room;
  char *_address;
};

/***************************************************************************/

class ResponseNode: public Response, public Node{
public:
  // Constructors/destructors
  ResponseNode( char *string );    //parse it
  ResponseNode( int parent, int room, char *address );
  ~ResponseNode();
};

/***************************************************************************/

class ResponseFile{
public:
  ResponseFile( char *filepath, int load = 0 );
  ~ResponseFile();

  // Accessors
  List *responselist();

  // File actions
  void load();
  void add( int parent, OptionArray &children, char *author );
  void add( int parent, int child, char *author );

  int respond( int room );   // If there is an author for this room, respond
  
private:
  int _loaded;        // Is the file loaded?
  char *_filepath;
  char *_filename;

  List *_responselist;
};

/***************************************************************************/

#endif

/*
 * $Log: response.H,v $
 * Revision 1.2  1994/12/15  19:51:19  asf
 * Added the capability to store the parent of the room along with the room.
 *
 * Revision 1.1  1994/11/06  13:06:33  asf
 * Initial revision
 *
 */
