/*
 * $Id: undo.C,v 1.1 1994/08/20 22:06:30 asf Exp $
 */

/*
    This file is part of Addventure
    Copyright (C) 1994  Allen S. Firstenberg
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "undo.H"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define SEPCHAR '-'

/***************************************************************************/

// Constructor/Destructor
Undo::Undo( char *coded ){
  char *tmp_coded;
  char *roomstr;
  char *seperator;
  char *parentstr;

  if( coded ){
    // Copy
    tmp_coded = (char *)malloc( strlen(coded) + 1 );
    strcpy( tmp_coded, coded );

    // Parse
    roomstr = tmp_coded;
    seperator = strchr( tmp_coded, SEPCHAR );
    if( seperator ){
      // Turn the seperator into the roomstr null termination
      *seperator = '\0';
      
      // The parent is here
      parentstr = seperator + 1;
    } else {
      parentstr = "0";
    }

    // Get the values
    v_room = atoi( roomstr );
    v_parent = atoi( parentstr );
    
  } else {
    // Set everything to zero
    v_room = 0;
    v_parent = 0;
  }
}

//---------------------------------------------------------------------------

Undo::Undo( int room, int parent ){
  v_room = room;
  v_parent = parent;
}

//---------------------------------------------------------------------------

Undo::~Undo(){
}

//---------------------------------------------------------------------------
// Accessors

char *Undo::coded_value(){
  /*
   * Return a newly allocated string
   */
  char *ret;

  ret = (char *)malloc( 50 );    // @@@

  sprintf( ret, "%d%c%d", v_room, SEPCHAR, v_parent );

  return ret;
}

//---------------------------------------------------------------------------

int Undo::room(){
  return v_room;
}

//---------------------------------------------------------------------------

int Undo::parent(){
  return v_parent;
}

/***************************************************************************/

/*
 * $Log: undo.C,v $
 * Revision 1.1  1994/08/20  22:06:30  asf
 * Initial revision
 *
 */
